/*--------------------------------------------------------------------------
 *  Copyright 2004 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ Project
//
// PullParserUtil.java
// Since: 2005/01/11
//
// $URL: http://www.xerial.org/svn/project/XerialJ/trunk/xerial-core/src/main/java/org/xerial/util/xml/pullparser/PullParserUtil.java $ 
// $Author: leo $
//--------------------------------------
package org.xerial.util.xml.pullparser;

import java.io.IOException;
import java.io.Reader;

import org.xerial.util.xml.XMLException;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlPullParserFactory;

import static org.xmlpull.v1.XmlPullParser.*;

/** XMLpull parser֗Ɏg߂̃[eBeBQ
 * @author leo
 *
 */
public class PullParserUtil
{

    /** tagɂǂ蒅܂ŁAparsei߂
     * @param tagName ڕWtag
     * @param pullParser pull parser
     * @return ړItagtrue, ȂfalseBtrue̎A
     * pull parseŕASTART_TAĜƂɃJ[\ԂɂȂ
     * @throws XmlPullParserException
     * @throws IOException
     */
    static public boolean parseUntil(String tagName, XmlPullParser pullParser) throws XmlPullParserException, IOException
    {
        while(pullParser.next() != END_DOCUMENT)
        {
            int state = pullParser.getEventType();
            if(state == START_TAG)
            {
                if(tagName.equals(pullParser.getName()))
                    return true; // found the target tag
            }
        }
        return false;
    }
    
    /**
     * vp[T̐⏕
     * @param xmlReader XMLǂݍreader
     * @return pull parser̃CX^X
     * @throws XMLParserException parser̐Ɏs
     */
    static public XmlPullParser newParser(Reader xmlReader) throws XMLException
    {
        XmlPullParser parser;
        try
        {
            parser = XmlPullParserFactory.newInstance().newPullParser();
            parser.setInput(xmlReader);
            return parser;
        }
        catch(XmlPullParserException e)
        {
            throw new XMLException(e);
        }
    }

}




